/*  m_mchange.c written by warknite (warknite@warknite.com)
 *  for newnet's version of hybrid
 *
 *  allows remote mode changing by services (used for setting +r)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: m_mchange.c,v 1.1 2004/01/03 15:29:42 stacy Exp $
 */

#include "stdinc.h"
#include "tools.h"
#include "common.h"  
#include "handlers.h"
#include "client.h"
#include "hash.h"
#include "channel.h"
#include "channel_mode.h"
#include "hash.h"
#include "ircd.h"
#include "numeric.h"
#include "s_conf.h"
#include "s_serv.h"
#include "send.h"
#include "irc_string.h"
#include "s_conf.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"
#include "hook.h"

static void ms_mchange(struct Client*, struct Client*, int, char**);

struct Message mchange_msgtab = {
  "MCHANGE", 0, 0, 0, 0, MFLG_SLOW, 0L,
  {m_unregistered, m_not_oper, ms_mchange, m_ignore}
};

#ifndef STATIC_MODULES
void
_modinit(void)
{
  mod_add_cmd(&mchange_msgtab);
}

void
_moddeinit(void)
{
  mod_del_cmd(&mchange_msgtab);
}

const char *_version = "$Revision: 1.1 $";
#endif

/*
** ms_mchange
**      parv[0] = sender prefix
**      parv[1] = nickname
**      parv[2] = modes to set
*/
static void
ms_mchange(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
{
  if (parc < 3 || BadPtr(parv[1]) || BadPtr(parv[2])) return;
  else if (IsServer(source_p)) return;
  else if (!(source_p->umodes & UMODE_NOKICK)) return;

  if (hunt_server(client_p, source_p, ":%s MCHANGE %s %s", 1, parc, parv) != HUNTED_ISME)
  {
     return;
  }
  user_mode(client_p, source_p, parc, parv);   /* Set user mode */
}
